function PK1IV1c 
%PK1IV1c explicit solution for drug amounts and concentrations. 
%   PK1IV1c produced a graph with profiles for drug amounts and 
%   drug concentrations based on the explicit solution for a one 
%   compartment PK model with IV input and first order elimination 

clear; clc; close all;
p.V = 5.0;     % L   
p.k10 = 1.0;   % mg/h
dose = 100;    % mg 
timeEnd = 10;  % h

t = 0:0.1:timeEnd;
c = dose/p.V*exp(-p.k10*t);
a = c*p.V;
plot(t,a,'-r',t,c,'b-','lineWidth',2)
legend('Drug amounts [mg]','Drug concentrations [mg/L]')
xlabel('Time (h)')
ylabel('Value')

end 
