% Create SimBiology Model.
m1 = sbiomodel('PKmodel');

% Add Compartment and Species
c1 = addcompartment(m1, 'unnamed');
s1 = addspecies(c1, 'species_1', 'InitialAmount', 10.0);
s2 = addspecies(c1, 'species_2');
s3 = addspecies(m1, 'species_3');
s4 = addspecies(m1, 'AUC3');

% Add Reactions
r1 = addreaction(m1, 'species_1 -> species_2');
r2 = addreaction(m1, 'species_2 -> null');
set(r1, 'ReactionRate', 'ka*species_1');
set(r2, 'ReactionRate', 'ke*species_2');

% Add Parameters
p1 = addparameter(m1, 'ka', 1.0);
p2 = addparameter(m1, 'ke', 1.0);
p3 = addparameter(m1, 'V', 2.0);

% Add Rules
rule1 = addrule(m1, 'species_3 = species_2/V');
set(rule1, 'RuleType', 'repeatedAssignment');
rule2 = addrule(m1, 'AUC3 =species_3', 'RuleType', 'rate');

% Add Rules
sbiosaveproject('PKmodel1.sbproj', 'm1');
