function varargout = calpot(varargin)
% CALPOT MATLAB code for calpot.fig
%      CALPOT, by itself, creates a new CALPOT or raises the existing
%      singleton*.
%
%      H = CALPOT returns the handle to a new CALPOT or the handle to
%      the existing singleton*.
%
%      CALPOT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CALPOT.M with the given input arguments.
%
%      CALPOT('Property','Value',...) creates a new CALPOT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before calpot_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to calpot_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help calpot

% Last Modified by GUIDE v2.5 13-Aug-2012 00:01:29

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @calpot_OpeningFcn, ...
                   'gui_OutputFcn',  @calpot_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT
end


% --- Executes just before calpot is made visible.
function calpot_OpeningFcn(hObject, ~, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to calpot (see VARARGIN)

% Choose default command line output for calpot
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes calpot wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --------- Added (BEGIN) ------- 
global data
% values at rest
data.KpIn  = 400; data.KpOut  = 20;  data.PK  = 1;    data.zK  =  1;
data.NapIn = 50;  data.NapOut = 440; data.PNa = 0.05; data.zNa =  1;
data.ClmIn = 52;  data.ClmOut = 560; data.PCl = 0.45; data.zCl = -1;
data.temp = 20;

% mapping initial values to the text boxes in GUI
set(handles.K1,   'String', data.KpIn) 
set(handles.K2,   'String', data.KpOut) 
set(handles.K3,   'String', data.PK)
set(handles.Na1,  'String', data.NapIn) 
set(handles.Na2,  'String', data.NapOut) 
set(handles.Na3,  'String', data.PNa)
set(handles.Cl1,  'String', data.ClmIn) 
set(handles.Cl2,  'String', data.ClmOut) 
set(handles.Cl3,  'String', data.PCl)
set(handles.temp, 'String', data.temp );

% compute according to Nernst and Goldman equations
[rp, epK, epNa, epCl, ~, ~, ~] = resting();
% mapping computed values to the text boxes in GUI
set(handles.Resting, 'String', num2str(rp)) 
set(handles.EK,      'String', num2str(epK)) 
set(handles.ENa,     'String', num2str(epNa)) 
set(handles.ECl,     'String', num2str(epCl)) 
% --------- Added (END) ------- 

end


% --- Outputs from this function are returned to the command line.
function varargout = calpot_OutputFcn(~, ~, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
end

% --- Executes on button press in Calculate.
function Calculate_Callback(~, ~, handles) %#ok<DEFNU>
% hObject    handle to Calculate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% ------------------ Added (BEGIN) ------------------
global data
data.KpIn   = str2num(get(handles.K1,  'String'));  %#ok<*ST2NM>
data.KpOut  = str2num(get(handles.K2,  'String')); 
data.PK     = str2num(get(handles.K3,  'String'));
data.NapIn  = str2num(get(handles.Na1, 'String')); 
data.NapOut = str2num(get(handles.Na2, 'String')); 
data.PNa    = str2num(get(handles.Na3, 'String'));
data.ClmIn  = str2num(get(handles.Cl1, 'String')); 
data.ClmOut = str2num(get(handles.Cl2, 'String')); 
data.PCl    = str2num(get(handles.Cl3, 'String'));
data.temp   = str2num(get(handles.temp,'String'));

% compute according to Nernst and Goldman equations
[rp, epK, epNa, epCl, ~, ~, ~] = resting();
% mapping computed values to the text boxes in GUI
set(handles.Resting, 'String', num2str(rp)) 
set(handles.EK, 'String', num2str(epK)) 
set(handles.ENa, 'String', num2str(epNa)) 
set(handles.ECl, 'String', num2str(epCl)) 
% ------------------ Added (END) ------------------

end


% --- Executes during object creation, after setting all properties.
function K1_CreateFcn(hObject, ~, ~) %#ok<DEFNU>
% hObject    handle to K1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

end


% --- Executes during object creation, after setting all properties.
function K2_CreateFcn(hObject, ~, ~) %#ok<DEFNU>
% hObject    handle to K2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

end


% --- Executes during object creation, after setting all properties.
function K3_CreateFcn(hObject, ~, ~) %#ok<DEFNU>
% hObject    handle to K3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

end


% --- Executes during object creation, after setting all properties.
function Na1_CreateFcn(hObject, ~, ~) %#ok<DEFNU>
% hObject    handle to Na1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

end



% --- Executes during object creation, after setting all properties.
function Na2_CreateFcn(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
% hObject    handle to Na2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
end



% --- Executes during object creation, after setting all properties.
function Na3_CreateFcn(hObject, ~, ~) %#ok<DEFNU>
% hObject    handle to Na3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
end


% --- Executes during object creation, after setting all properties.
function Cl1_CreateFcn(hObject, ~, ~) %#ok<DEFNU>
% hObject    handle to Cl1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

end


% --- Executes during object creation, after setting all properties.
function Cl2_CreateFcn(hObject, ~, ~) %#ok<DEFNU>
% hObject    handle to Cl2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

end


% --- Executes during object creation, after setting all properties.
function Cl3_CreateFcn(hObject, ~, ~) %#ok<DEFNU>
% hObject    handle to Cl3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

end


% --- Executes during object creation, after setting all properties.
function Resting_CreateFcn(~, ~, ~) %#ok<DEFNU>
% hObject    handle to Resting (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
end


function temp_Callback(~, ~, ~) %#ok<DEFNU>
% hObject    handle to temp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of temp as text
%        str2double(get(hObject,'String')) returns contents of temp as a double
end


% --- Executes during object creation, after setting all properties.
function temp_CreateFcn(hObject, ~, ~) %#ok<DEFNU>
% hObject    handle to temp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
end


function [V, EK, ENa, ECl, VK, VNa, VCl] = resting()
%RESTING Compute the equilibrium and resting potential
%   [V, EK, ENA, ECL, VK,VNA, VCL] = RESTING() calculates the
%   equilibrium and resting potential according to  Nernst and
%   Goldman equations.
%   Input arguments: passed globally
%   Output: |V| - resting potential; |EK|,|ENa|,|ECl| - equilibrium
%   potentials for K Na Cl channels, repectively. |VK|,|VNa|,|VCl| -
%   equilibrium potentials calculated with another fomula.
  
global data
KpIn  = data.KpIn;  KpOut  = data.KpOut;  
PK    = data.PK;    zK     = data.zK;
NapIn = data.NapIn; NapOut = data.NapOut; 
PNa   = data.PNa;   zNa    = data.zNa;
ClmIn = data.ClmIn; ClmOut = data.ClmOut; 
PCl   = data.PCl;   zCl    = data.zCl;
temp  = data.temp;

R = 8.314;                  % J/(Kmol)
F = 96485.3415;             % C/mol or J/(Vmol)  96 485.3415 
T = temp + 273.15;          % Kelvin = Celsius + 273.15)

% Equilibrium 
EK  = R*T/F/zK*log(KpOut/KpIn)*1000;                    % in mV
ENa = R*T/F/zNa*log(NapOut/NapIn)*1000;                 % in mV
ECl = R*T/F/zCl*log(ClmOut/ClmIn)*1000;                 % in mV
V = R*T/F*log((NapOut*PNa +  KpOut*PK + ClmIn*PCl)/ ...
    (NapIn*PNa +  KpIn*PK + ClmOut*PCl))*1000 ;         % in mV

% Equilibrium (useing an equivalent fomula)
k = 1.38E-23;          % Boltzman constant [J/K]
q = 1.602E-19;         % magnitude of the electronic charge [C]
VK  = k*T/q*log(KpOut/KpIn)*1000;                       % in mV
VNa = k*T/q*log(NapOut/NapIn)*1000;                     % in mV
VCl = k*T/q*log(ClmOut/ClmIn)*1000;                     % in mV

end


% --- Executes during object creation, after setting all properties.
function figure_CreateFcn(~, ~, ~) %#ok<DEFNU>
% hObject    handle to figure (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate figure
end


function K3_Callback(~, ~, ~) %#ok<DEFNU>
% hObject    handle to K3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of K3 as text
%        str2double(get(hObject,'String')) returns contents of K3 as a double
end


function K1_Callback(~, ~, ~) %#ok<DEFNU>
% hObject    handle to K1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of K1 as text
%        str2double(get(hObject,'String')) returns contents of K1 as a double
end


function K2_Callback(~, ~, ~) %#ok<DEFNU>
% hObject    handle to K2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of K2 as text
%        str2double(get(hObject,'String')) returns contents of K2 as a double
end


function Na1_Callback(~, ~, ~) %#ok<DEFNU>
% hObject    handle to Na1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Na1 as text
%        str2double(get(hObject,'String')) returns contents of Na1 as a double
end


function Na2_Callback(~, ~, ~) %#ok<DEFNU>
% hObject    handle to Na2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Na2 as text
%        str2double(get(hObject,'String')) returns contents of Na2 as a double
end


function Na3_Callback(~, ~, ~) %#ok<DEFNU>
% hObject    handle to Na3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Na3 as text
%        str2double(get(hObject,'String')) returns contents of Na3 as a double
end


function Cl1_Callback(~, ~, ~) %#ok<DEFNU>
% hObject    handle to Cl1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Cl1 as text
%        str2double(get(hObject,'String')) returns contents of Cl1 as a double
end


function Cl2_Callback(~, ~, ~) %#ok<DEFNU>
% hObject    handle to Cl2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Cl2 as text
%        str2double(get(hObject,'String')) returns contents of Cl2 as a double
end


function Cl3_Callback(~, ~, ~) %#ok<DEFNU>
% hObject    handle to Cl3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Cl3 as text
%        str2double(get(hObject,'String')) returns contents of Cl3 as a double
end
