%FDENSITY The density function of the normal distribution. 
%   FDENSITY uses the Symbolic Math Toolbox to calculate the area 
%   under the density function of the normal distribution and 
%   produces a graph based on the analytical form of the function.
%   See also ezplot. 

syms f s m x a pis 
assume(s>0)
assume(m>0)
m = sym(0);
s = sym(1);
pis = sym(pi);
f = 1/(s*sqrt(2*pis))*exp(-(x-m)^2/s^2/2);
F=int(f,-a,a);
F2 = F*F;
Fa=limit(F,a,inf);
display(['area under the density function = ', char(Fa)])
f = 1/(s*sqrt(2*pis))*exp(-(x-m)^2/s^2/2);
set(axes, 'FontSize', 15)
h = ezplot(char(f), [-8 8]); hold on
xpoints = get(h, 'XData'); 
ypoints = get(h, 'YData');
set(h, 'Color', 'black', 'LineWidth', 2);
area(xpoints, ypoints, 'face', [0.8 0.8 0.8])
legend('f(x)', ['area = ' char(Fa)])
print('-r600', '-dtiff', ['density_',char(m),'_',char(s)]);

