% Generate Data to Fit
ka = 0.5; ke = 1.2; V = 2;
dose = 10; 
times = (0:10)';
conc = dose/V*ka/(ke-ka)*(exp(-ka*times)-exp(-ke*times));
conc_obs =conc .* (1 + 0.01*randn(length(conc),1));
set(axes, 'FontSize', 15); 
plot(data.time,data.Data(:,1:3),'LineWidth',2);   hold on
plot(times, conc_obs,'or','LineWidth',1.5)
xlabel('Time [h]');   ylabel('Value [units]')
legend('species_1','species_2','species_3','AUC3','Observed');
print('-r800', '-dtiff', 'fitdata.tif')

% Fit data
dataToFit = dataset(times,conc_obs) %#ok<NOPTS>
